/**
 * Copyright (c) 2025 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#include "input.h"
#include "util/random.h"
#include "display/render.h"

#include "rpg/entity/entity.h"

int32_t main(const int32_t argc, const char **argv) {
  inputInit();
  randomInit();
  renderInit();

  entity_t *ent;

  ent = &ENTITIES[0];
  entityInit(ent, ENTITY_TYPE_PLAYER);

  while(1) {
    inputUpdate();

    ent = ENTITIES;
    do {
      if(ent->type == ENTITY_TYPE_NULL) {
        ent++;
        continue;
      }
      entityUpdate(ent++);
    } while(ent < (ENTITIES + ENTITY_COUNT));

    if(!renderUpdate()) break;
  }

  return EXIT_SUCCESS;
}